///////////////////////////////////////////////////////////////-*-C-*-
//
// Copyright (c) 2007 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.  XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION
// "AS IS" AS  A COURTESY TO YOU.  BY PROVIDING  THIS DESIGN, CODE, OR
// INFORMATION  AS  ONE   POSSIBLE  IMPLEMENTATION  OF  THIS  FEATURE,
// APPLICATION OR  STANDARD, XILINX  IS MAKING NO  REPRESENTATION THAT
// THIS IMPLEMENTATION  IS FREE FROM  ANY CLAIMS OF  INFRINGEMENT, AND
// YOU ARE  RESPONSIBLE FOR OBTAINING  ANY RIGHTS YOU MAY  REQUIRE FOR
// YOUR  IMPLEMENTATION.   XILINX  EXPRESSLY  DISCLAIMS  ANY  WARRANTY
// WHATSOEVER  WITH RESPECT  TO  THE ADEQUACY  OF THE  IMPLEMENTATION,
// INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR REPRESENTATIONS THAT
// THIS IMPLEMENTATION  IS FREE  FROM CLAIMS OF  INFRINGEMENT, IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// 
//////////////////////////////////////////////////////////////////////

#include "ofdm_pktdetector_mimo_plbw.h"
#include "xparameters.h"
#include "xcope.h"

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_create(xc_iface_t **iface, void *config_table)
{
    // set up iface
    *iface = (xc_iface_t *) config_table;

#ifdef XC_DEBUG
    OFDM_PKTDETECTOR_MIMO_PLBW_Config *_config_table = config_table;

    if (_config_table->xc_create == NULL) {
        print("config_table.xc_create == NULL\r\n");
        exit(1);
    }
#endif

    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_release(xc_iface_t **iface) 
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_open(xc_iface_t *iface)
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_close(xc_iface_t *iface)
{
    // does nothing
    return XC_SUCCESS;
}

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_read(xc_iface_t *iface, xc_r_addr_t addr, uint32_t *value)
{
    *value = *((uint32_t *) addr);
    return XC_SUCCESS;
}

inline xc_status_t xc_ofdm_pktdetector_mimo_plbw_write(xc_iface_t *iface, xc_w_addr_t addr, const uint32_t value)
{
    *((uint32_t *) addr) = value;
    return XC_SUCCESS;
}

xc_status_t xc_ofdm_pktdetector_mimo_plbw_getshmem(xc_iface_t *iface, const char *name, void **shmem)
{
    OFDM_PKTDETECTOR_MIMO_PLBW_Config *_config_table = (OFDM_PKTDETECTOR_MIMO_PLBW_Config *) iface;

    if (strcmp("pktDet_idleDifs", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_idleDifs;
    }
    else if (strcmp("csma_avgThresh", name) == 0) {
        *shmem = (void *) & _config_table->csma_avgThresh;
    }
    else if (strcmp("csma_difsPeriod", name) == 0) {
        *shmem = (void *) & _config_table->csma_difsPeriod;
    }
    else if (strcmp("csma_enableBusy", name) == 0) {
        *shmem = (void *) & _config_table->csma_enableBusy;
    }
    else if (strcmp("csma_enableIdle", name) == 0) {
        *shmem = (void *) & _config_table->csma_enableIdle;
    }
    else if (strcmp("pktDet_avgLen", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_avgLen;
    }
    else if (strcmp("pktDet_avgThresh", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_avgThresh;
    }
    else if (strcmp("pktDet_clkRatioSel", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_clkRatioSel;
    }
    else if (strcmp("pktDet_detectionMask", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_detectionMask;
    }
    else if (strcmp("pktDet_detectionMode", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_detectionMode;
    }
    else if (strcmp("pktDet_masterReset", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_masterReset;
    }
    else if (strcmp("pktDet_reset", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_reset;
    }
    else if (strcmp("pktDet_resetDuration", name) == 0) {
        *shmem = (void *) & _config_table->pktDet_resetDuration;
    } else { shmem = NULL; return XC_FAILURE; } 

    return XC_SUCCESS;
}
