///////////////////////////////////////////////////////////////-*-C-*-
//
// Copyright (c) 2007 Xilinx, Inc.  All rights reserved.
//
// Xilinx, Inc.  XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION
// "AS IS" AS  A COURTESY TO YOU.  BY PROVIDING  THIS DESIGN, CODE, OR
// INFORMATION  AS  ONE   POSSIBLE  IMPLEMENTATION  OF  THIS  FEATURE,
// APPLICATION OR  STANDARD, XILINX  IS MAKING NO  REPRESENTATION THAT
// THIS IMPLEMENTATION  IS FREE FROM  ANY CLAIMS OF  INFRINGEMENT, AND
// YOU ARE  RESPONSIBLE FOR OBTAINING  ANY RIGHTS YOU MAY  REQUIRE FOR
// YOUR  IMPLEMENTATION.   XILINX  EXPRESSLY  DISCLAIMS  ANY  WARRANTY
// WHATSOEVER  WITH RESPECT  TO  THE ADEQUACY  OF THE  IMPLEMENTATION,
// INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR REPRESENTATIONS THAT
// THIS IMPLEMENTATION  IS FREE  FROM CLAIMS OF  INFRINGEMENT, IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// 
//////////////////////////////////////////////////////////////////////

#ifndef __XL_OFDM_TXRX_SUPERMIMO_PLBW_H__
#define __XL_OFDM_TXRX_SUPERMIMO_PLBW_H__

#include "xbasic_types.h"
#include "xstatus.h"
#include "xcope.h"

typedef struct {
    uint32_t version;
    // Pointers to low-level functions
    xc_status_t (*xc_create)(xc_iface_t **, void *);
    xc_status_t (*xc_release)(xc_iface_t **);
    xc_status_t (*xc_open)(xc_iface_t *);
    xc_status_t (*xc_close)(xc_iface_t *);
    xc_status_t (*xc_read)(xc_iface_t *, xc_r_addr_t, uint32_t *);
    xc_status_t (*xc_write)(xc_iface_t *, xc_w_addr_t, const uint32_t);
    xc_status_t (*xc_get_shmem)(xc_iface_t *, const char *, void **shmem);
    // Optional parameters
    // (empty)
    // Memory map information
    uint32_t Rx_BER_Errors;
    uint32_t Rx_BER_Errors_n_bits;
    uint32_t Rx_BER_Errors_bin_pt;
    // uint32_t Rx_BER_Errors_attr;
    uint32_t Rx_BER_TotalBits;
    uint32_t Rx_BER_TotalBits_n_bits;
    uint32_t Rx_BER_TotalBits_bin_pt;
    // uint32_t Rx_BER_TotalBits_attr;
    uint32_t Rx_ControlBits_r;
    uint32_t Rx_ControlBits_r_n_bits;
    uint32_t Rx_ControlBits_r_bin_pt;
    // uint32_t Rx_ControlBits_r_attr;
    uint32_t Rx_Gains;
    uint32_t Rx_Gains_n_bits;
    uint32_t Rx_Gains_bin_pt;
    // uint32_t Rx_Gains_attr;
    uint32_t Rx_OFDM_SymbolCounts_r;
    uint32_t Rx_OFDM_SymbolCounts_r_n_bits;
    uint32_t Rx_OFDM_SymbolCounts_r_bin_pt;
    // uint32_t Rx_OFDM_SymbolCounts_r_attr;
    uint32_t Rx_PktDet_Delay_r;
    uint32_t Rx_PktDet_Delay_r_n_bits;
    uint32_t Rx_PktDet_Delay_r_bin_pt;
    // uint32_t Rx_PktDet_Delay_r_attr;
    uint32_t Rx_PktDet_LongCorr_Params_r;
    uint32_t Rx_PktDet_LongCorr_Params_r_n_bits;
    uint32_t Rx_PktDet_LongCorr_Params_r_bin_pt;
    // uint32_t Rx_PktDet_LongCorr_Params_r_attr;
    uint32_t Rx_pktByteNums_r;
    uint32_t Rx_pktByteNums_r_n_bits;
    uint32_t Rx_pktByteNums_r_bin_pt;
    // uint32_t Rx_pktByteNums_r_attr;
    uint32_t Rx_pktDone_interruptStatus;
    uint32_t Rx_pktDone_interruptStatus_n_bits;
    uint32_t Rx_pktDone_interruptStatus_bin_pt;
    // uint32_t Rx_pktDone_interruptStatus_attr;
    uint32_t TxRx_AutoReply_Action0_r;
    uint32_t TxRx_AutoReply_Action0_r_n_bits;
    uint32_t TxRx_AutoReply_Action0_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action0_r_attr;
    uint32_t TxRx_AutoReply_Action1_r;
    uint32_t TxRx_AutoReply_Action1_r_n_bits;
    uint32_t TxRx_AutoReply_Action1_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action1_r_attr;
    uint32_t TxRx_AutoReply_Action2_r;
    uint32_t TxRx_AutoReply_Action2_r_n_bits;
    uint32_t TxRx_AutoReply_Action2_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action2_r_attr;
    uint32_t TxRx_AutoReply_Action3_r;
    uint32_t TxRx_AutoReply_Action3_r_n_bits;
    uint32_t TxRx_AutoReply_Action3_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action3_r_attr;
    uint32_t TxRx_AutoReply_Action4_r;
    uint32_t TxRx_AutoReply_Action4_r_n_bits;
    uint32_t TxRx_AutoReply_Action4_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action4_r_attr;
    uint32_t TxRx_AutoReply_Action5_r;
    uint32_t TxRx_AutoReply_Action5_r_n_bits;
    uint32_t TxRx_AutoReply_Action5_r_bin_pt;
    // uint32_t TxRx_AutoReply_Action5_r_attr;
    uint32_t TxRx_AutoReply_Match0_r;
    uint32_t TxRx_AutoReply_Match0_r_n_bits;
    uint32_t TxRx_AutoReply_Match0_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match0_r_attr;
    uint32_t TxRx_AutoReply_Match1_r;
    uint32_t TxRx_AutoReply_Match1_r_n_bits;
    uint32_t TxRx_AutoReply_Match1_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match1_r_attr;
    uint32_t TxRx_AutoReply_Match2_r;
    uint32_t TxRx_AutoReply_Match2_r_n_bits;
    uint32_t TxRx_AutoReply_Match2_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match2_r_attr;
    uint32_t TxRx_AutoReply_Match3_r;
    uint32_t TxRx_AutoReply_Match3_r_n_bits;
    uint32_t TxRx_AutoReply_Match3_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match3_r_attr;
    uint32_t TxRx_AutoReply_Match4_r;
    uint32_t TxRx_AutoReply_Match4_r_n_bits;
    uint32_t TxRx_AutoReply_Match4_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match4_r_attr;
    uint32_t TxRx_AutoReply_Match5_r;
    uint32_t TxRx_AutoReply_Match5_r_n_bits;
    uint32_t TxRx_AutoReply_Match5_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match5_r_attr;
    uint32_t TxRx_AutoReply_Match6_r;
    uint32_t TxRx_AutoReply_Match6_r_n_bits;
    uint32_t TxRx_AutoReply_Match6_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match6_r_attr;
    uint32_t TxRx_AutoReply_Match7_r;
    uint32_t TxRx_AutoReply_Match7_r_n_bits;
    uint32_t TxRx_AutoReply_Match7_r_bin_pt;
    // uint32_t TxRx_AutoReply_Match7_r_attr;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_r;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_r_n_bits;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_r_bin_pt;
    // uint32_t TxRx_Interrupt_PktBuf_Ctrl_r_attr;
    uint32_t Tx_ControlBits_r;
    uint32_t Tx_ControlBits_r_n_bits;
    uint32_t Tx_ControlBits_r_bin_pt;
    // uint32_t Tx_ControlBits_r_attr;
    uint32_t Tx_OFDM_SymCounts_r;
    uint32_t Tx_OFDM_SymCounts_r_n_bits;
    uint32_t Tx_OFDM_SymCounts_r_bin_pt;
    // uint32_t Tx_OFDM_SymCounts_r_attr;
    uint32_t Tx_PktRunning;
    uint32_t Tx_PktRunning_n_bits;
    uint32_t Tx_PktRunning_bin_pt;
    // uint32_t Tx_PktRunning_attr;
    uint32_t Tx_Start_Reset_Control_r;
    uint32_t Tx_Start_Reset_Control_r_n_bits;
    uint32_t Tx_Start_Reset_Control_r_bin_pt;
    // uint32_t Tx_Start_Reset_Control_r_attr;
    uint32_t midPacketRSSI;
    uint32_t midPacketRSSI_n_bits;
    uint32_t midPacketRSSI_bin_pt;
    // uint32_t midPacketRSSI_attr;
    uint32_t pktDet_controlBits_r;
    uint32_t pktDet_controlBits_r_n_bits;
    uint32_t pktDet_controlBits_r_bin_pt;
    // uint32_t pktDet_controlBits_r_attr;
    uint32_t pktDet_durations_r;
    uint32_t pktDet_durations_r_n_bits;
    uint32_t pktDet_durations_r_bin_pt;
    // uint32_t pktDet_durations_r_attr;
    uint32_t pktDet_status;
    uint32_t pktDet_status_n_bits;
    uint32_t pktDet_status_bin_pt;
    // uint32_t pktDet_status_attr;
    uint32_t pktDet_thresholds_r;
    uint32_t pktDet_thresholds_r_n_bits;
    uint32_t pktDet_thresholds_r_bin_pt;
    // uint32_t pktDet_thresholds_r_attr;
    uint32_t Rx_AF_TxScaling_w;
    uint32_t Rx_AF_TxScaling_w_n_bits;
    uint32_t Rx_AF_TxScaling_w_bin_pt;
    // uint32_t Rx_AF_TxScaling_w_attr;
    uint32_t Rx_Constellation_Scaling_w;
    uint32_t Rx_Constellation_Scaling_w_n_bits;
    uint32_t Rx_Constellation_Scaling_w_bin_pt;
    // uint32_t Rx_Constellation_Scaling_w_attr;
    uint32_t Rx_ControlBits_w;
    uint32_t Rx_ControlBits_w_n_bits;
    uint32_t Rx_ControlBits_w_bin_pt;
    // uint32_t Rx_ControlBits_w_attr;
    uint32_t Rx_FreqOffFilt_B_KI_w;
    uint32_t Rx_FreqOffFilt_B_KI_w_n_bits;
    uint32_t Rx_FreqOffFilt_B_KI_w_bin_pt;
    // uint32_t Rx_FreqOffFilt_B_KI_w_attr;
    uint32_t Rx_FreqOffFilt_B_KP_w;
    uint32_t Rx_FreqOffFilt_B_KP_w_n_bits;
    uint32_t Rx_FreqOffFilt_B_KP_w_bin_pt;
    // uint32_t Rx_FreqOffFilt_B_KP_w_attr;
    uint32_t Rx_MinReqPilotChanMag_w;
    uint32_t Rx_MinReqPilotChanMag_w_n_bits;
    uint32_t Rx_MinReqPilotChanMag_w_bin_pt;
    // uint32_t Rx_MinReqPilotChanMag_w_attr;
    uint32_t Rx_OFDM_SymbolCounts_w;
    uint32_t Rx_OFDM_SymbolCounts_w_n_bits;
    uint32_t Rx_OFDM_SymbolCounts_w_bin_pt;
    // uint32_t Rx_OFDM_SymbolCounts_w_attr;
    uint32_t Rx_PhaseNoiseTrack_K_w;
    uint32_t Rx_PhaseNoiseTrack_K_w_n_bits;
    uint32_t Rx_PhaseNoiseTrack_K_w_bin_pt;
    // uint32_t Rx_PhaseNoiseTrack_K_w_attr;
    uint32_t Rx_PktDet_Delay_w;
    uint32_t Rx_PktDet_Delay_w_n_bits;
    uint32_t Rx_PktDet_Delay_w_bin_pt;
    // uint32_t Rx_PktDet_Delay_w_attr;
    uint32_t Rx_PktDet_LongCorr_Params_w;
    uint32_t Rx_PktDet_LongCorr_Params_w_n_bits;
    uint32_t Rx_PktDet_LongCorr_Params_w_bin_pt;
    // uint32_t Rx_PktDet_LongCorr_Params_w_attr;
    uint32_t Rx_PreCFO_Options_w;
    uint32_t Rx_PreCFO_Options_w_n_bits;
    uint32_t Rx_PreCFO_Options_w_bin_pt;
    // uint32_t Rx_PreCFO_Options_w_attr;
    uint32_t Rx_pktByteNums_w;
    uint32_t Rx_pktByteNums_w_n_bits;
    uint32_t Rx_pktByteNums_w_bin_pt;
    // uint32_t Rx_pktByteNums_w_attr;
    uint32_t Rx_pktDet_Tresholds_w;
    uint32_t Rx_pktDet_Tresholds_w_n_bits;
    uint32_t Rx_pktDet_Tresholds_w_bin_pt;
    // uint32_t Rx_pktDet_Tresholds_w_attr;
    uint32_t TxRx_AutoReply_Action0_w;
    uint32_t TxRx_AutoReply_Action0_w_n_bits;
    uint32_t TxRx_AutoReply_Action0_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action0_w_attr;
    uint32_t TxRx_AutoReply_Action1_w;
    uint32_t TxRx_AutoReply_Action1_w_n_bits;
    uint32_t TxRx_AutoReply_Action1_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action1_w_attr;
    uint32_t TxRx_AutoReply_Action2_w;
    uint32_t TxRx_AutoReply_Action2_w_n_bits;
    uint32_t TxRx_AutoReply_Action2_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action2_w_attr;
    uint32_t TxRx_AutoReply_Action3_w;
    uint32_t TxRx_AutoReply_Action3_w_n_bits;
    uint32_t TxRx_AutoReply_Action3_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action3_w_attr;
    uint32_t TxRx_AutoReply_Action4_w;
    uint32_t TxRx_AutoReply_Action4_w_n_bits;
    uint32_t TxRx_AutoReply_Action4_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action4_w_attr;
    uint32_t TxRx_AutoReply_Action5_w;
    uint32_t TxRx_AutoReply_Action5_w_n_bits;
    uint32_t TxRx_AutoReply_Action5_w_bin_pt;
    // uint32_t TxRx_AutoReply_Action5_w_attr;
    uint32_t TxRx_AutoReply_Match0_w;
    uint32_t TxRx_AutoReply_Match0_w_n_bits;
    uint32_t TxRx_AutoReply_Match0_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match0_w_attr;
    uint32_t TxRx_AutoReply_Match1_w;
    uint32_t TxRx_AutoReply_Match1_w_n_bits;
    uint32_t TxRx_AutoReply_Match1_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match1_w_attr;
    uint32_t TxRx_AutoReply_Match2_w;
    uint32_t TxRx_AutoReply_Match2_w_n_bits;
    uint32_t TxRx_AutoReply_Match2_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match2_w_attr;
    uint32_t TxRx_AutoReply_Match3_w;
    uint32_t TxRx_AutoReply_Match3_w_n_bits;
    uint32_t TxRx_AutoReply_Match3_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match3_w_attr;
    uint32_t TxRx_AutoReply_Match4_w;
    uint32_t TxRx_AutoReply_Match4_w_n_bits;
    uint32_t TxRx_AutoReply_Match4_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match4_w_attr;
    uint32_t TxRx_AutoReply_Match5_w;
    uint32_t TxRx_AutoReply_Match5_w_n_bits;
    uint32_t TxRx_AutoReply_Match5_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match5_w_attr;
    uint32_t TxRx_AutoReply_Match6_w;
    uint32_t TxRx_AutoReply_Match6_w_n_bits;
    uint32_t TxRx_AutoReply_Match6_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match6_w_attr;
    uint32_t TxRx_AutoReply_Match7_w;
    uint32_t TxRx_AutoReply_Match7_w_n_bits;
    uint32_t TxRx_AutoReply_Match7_w_bin_pt;
    // uint32_t TxRx_AutoReply_Match7_w_attr;
    uint32_t TxRx_FFT_Scaling_w;
    uint32_t TxRx_FFT_Scaling_w_n_bits;
    uint32_t TxRx_FFT_Scaling_w_bin_pt;
    // uint32_t TxRx_FFT_Scaling_w_attr;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_w;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_w_n_bits;
    uint32_t TxRx_Interrupt_PktBuf_Ctrl_w_bin_pt;
    // uint32_t TxRx_Interrupt_PktBuf_Ctrl_w_attr;
    uint32_t TxRx_Pilots_Index_w;
    uint32_t TxRx_Pilots_Index_w_n_bits;
    uint32_t TxRx_Pilots_Index_w_bin_pt;
    // uint32_t TxRx_Pilots_Index_w_attr;
    uint32_t TxRx_Pilots_Values_w;
    uint32_t TxRx_Pilots_Values_w_n_bits;
    uint32_t TxRx_Pilots_Values_w_bin_pt;
    // uint32_t TxRx_Pilots_Values_w_attr;
    uint32_t Tx_ControlBits_w;
    uint32_t Tx_ControlBits_w_n_bits;
    uint32_t Tx_ControlBits_w_bin_pt;
    // uint32_t Tx_ControlBits_w_attr;
    uint32_t Tx_OFDM_SymCounts_w;
    uint32_t Tx_OFDM_SymCounts_w_n_bits;
    uint32_t Tx_OFDM_SymCounts_w_bin_pt;
    // uint32_t Tx_OFDM_SymCounts_w_attr;
    uint32_t Tx_PreambleMasking_w;
    uint32_t Tx_PreambleMasking_w_n_bits;
    uint32_t Tx_PreambleMasking_w_bin_pt;
    // uint32_t Tx_PreambleMasking_w_attr;
    uint32_t Tx_Scaling_w;
    uint32_t Tx_Scaling_w_n_bits;
    uint32_t Tx_Scaling_w_bin_pt;
    // uint32_t Tx_Scaling_w_attr;
    uint32_t Tx_Start_Reset_Control_w;
    uint32_t Tx_Start_Reset_Control_w_n_bits;
    uint32_t Tx_Start_Reset_Control_w_bin_pt;
    // uint32_t Tx_Start_Reset_Control_w_attr;
    uint32_t pktDet_controlBits_w;
    uint32_t pktDet_controlBits_w_n_bits;
    uint32_t pktDet_controlBits_w_bin_pt;
    // uint32_t pktDet_controlBits_w_attr;
    uint32_t pktDet_durations_w;
    uint32_t pktDet_durations_w_n_bits;
    uint32_t pktDet_durations_w_bin_pt;
    // uint32_t pktDet_durations_w_attr;
    uint32_t pktDet_thresholds_w;
    uint32_t pktDet_thresholds_w_n_bits;
    uint32_t pktDet_thresholds_w_bin_pt;
    // uint32_t pktDet_thresholds_w_attr;
    uint32_t ChannelEstimates;
    // uint32_t ChannelEstimates_grant;
    // uint32_t ChannelEstimates_req;
    uint32_t ChannelEstimates_n_bits;
    uint32_t ChannelEstimates_bin_pt;
    uint32_t ChannelEstimates_depth;
    // uint32_t ChannelEstimates_attr;
    uint32_t RxModulation;
    // uint32_t RxModulation_grant;
    // uint32_t RxModulation_req;
    uint32_t RxModulation_n_bits;
    uint32_t RxModulation_bin_pt;
    uint32_t RxModulation_depth;
    // uint32_t RxModulation_attr;
    uint32_t TxHeaderTranslate;
    // uint32_t TxHeaderTranslate_grant;
    // uint32_t TxHeaderTranslate_req;
    uint32_t TxHeaderTranslate_n_bits;
    uint32_t TxHeaderTranslate_bin_pt;
    uint32_t TxHeaderTranslate_depth;
    // uint32_t TxHeaderTranslate_attr;
    uint32_t TxModulation;
    // uint32_t TxModulation_grant;
    // uint32_t TxModulation_req;
    uint32_t TxModulation_n_bits;
    uint32_t TxModulation_bin_pt;
    uint32_t TxModulation_depth;
    // uint32_t TxModulation_attr;
    // XPS parameters
    Xuint16  DeviceId;
    uint32_t  BaseAddr;
} OFDM_TXRX_SUPERMIMO_PLBW_Config;

extern OFDM_TXRX_SUPERMIMO_PLBW_Config OFDM_TXRX_SUPERMIMO_PLBW_ConfigTable[];

// forward declaration of low-level functions
xc_status_t xc_ofdm_txrx_supermimo_plbw_create(xc_iface_t **iface, void *config_table);
xc_status_t xc_ofdm_txrx_supermimo_plbw_release(xc_iface_t **iface) ;
xc_status_t xc_ofdm_txrx_supermimo_plbw_open(xc_iface_t *iface);
xc_status_t xc_ofdm_txrx_supermimo_plbw_close(xc_iface_t *iface);
xc_status_t xc_ofdm_txrx_supermimo_plbw_read(xc_iface_t *iface, xc_r_addr_t addr, uint32_t *value);
xc_status_t xc_ofdm_txrx_supermimo_plbw_write(xc_iface_t *iface, xc_w_addr_t addr, const uint32_t value);
xc_status_t xc_ofdm_txrx_supermimo_plbw_getshmem(xc_iface_t *iface, const char *name, void **shmem);

#endif

