#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:/home/murphpo/work/refdes13/OFDM_ReferenceDesign_v13_v18_TxFix/system.xmp
#
# WARNING : This file will be re-generated every time a command
# to run a make target is invoked. So, any changes made to this  
# file manually, will be lost when make is invoked next. 
#################################################################

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# /home/murphpo/work/refdes13/OFDM_ReferenceDesign_v13_v18_TxFix/system.mhs
# The software specification of the system is in file :
# /home/murphpo/work/refdes13/OFDM_ReferenceDesign_v13_v18_TxFix/system.mss

include system_incl.make

#################################################################
# PHONY TARGETS
#################################################################
.PHONY: dummy
.PHONY: netlistclean
.PHONY: bitsclean
.PHONY: simclean
.PHONY: vpclean

#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral_model : Generates behavioral HDL models with BRAM initialization"
	@echo "  structural_model : Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo "  vp       : Generates virtual platform model"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bitsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  vpclean  : Deletes virtualplatform dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: $(SYSTEM_BIT)

ace: $(SYSTEM_ACE)

netlist: $(POSTSYN_NETLIST)

libs: $(LIBRARIES)

program: $(ALL_USER_ELF_FILES)

download: $(DOWNLOAD_BIT) dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: $(DOWNLOAD_BIT)

sim: $(DEFAULT_SIM_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD)  &

simmodel: $(DEFAULT_SIM_SCRIPT)

behavioral_model: $(BEHAVIORAL_SIM_SCRIPT)

structural_model: $(STRUCTURAL_SIM_SCRIPT)

vp: $(VPEXEC)

clean: hwclean libsclean programclean simclean vpclean
	rm -f _impact.cmd
	rm -f *.log

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f $(POSTSYN_NETLIST)
	rm -f platgen.log
	rm -f $(BMM_FILE)

bitsclean:
	rm -f $(SYSTEM_BIT)
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 
	rm -f implementation/$(SYSTEM)_map.ncd 
	rm -f __xps/$(SYSTEM)_routed

simclean: 
	rm -rf simulation/behavioral
	rm -f simgen.log

swclean: libsclean programclean
	@echo ""

libsclean: $(LIBSCLEAN_TARGETS)
	rm -f libgen.log

programclean: $(PROGRAMCLEAN_TARGETS)

vpclean:
	rm -rf virtualplatform
	rm -f vpgen.log

#################################################################
# SOFTWARE PLATFORM FLOW
#################################################################


$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)


ppc405_0_libsclean:
	rm -rf ppc405_0/

#################################################################
# SOFTWARE APPLICATION CSMAMAC
#################################################################

CSMAMAC_program: $(CSMAMAC_OUTPUT) 

$(CSMAMAC_OUTPUT) : $(CSMAMAC_SOURCES) $(CSMAMAC_HEADERS) $(CSMAMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/csmamac_compiler.opt
	@mkdir -p $(CSMAMAC_OUTPUT_DIR) 
	$(CSMAMAC_CC) $(CSMAMAC_CC_OPT) $(CSMAMAC_SOURCES) -o $(CSMAMAC_OUTPUT) \
	$(CSMAMAC_OTHER_CC_FLAGS) $(CSMAMAC_INCLUDES) $(CSMAMAC_LIBPATH) \
	$(CSMAMAC_CFLAGS) $(CSMAMAC_LFLAGS) 
	$(CSMAMAC_CC_SIZE) $(CSMAMAC_OUTPUT) 
	@echo ""

CSMAMAC_programclean:
	rm -f $(CSMAMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION AFMAC
#################################################################

AFMAC_program: $(AFMAC_OUTPUT) 

$(AFMAC_OUTPUT) : $(AFMAC_SOURCES) $(AFMAC_HEADERS) $(AFMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/afmac_compiler.opt
	@mkdir -p $(AFMAC_OUTPUT_DIR) 
	$(AFMAC_CC) $(AFMAC_CC_OPT) $(AFMAC_SOURCES) -o $(AFMAC_OUTPUT) \
	$(AFMAC_OTHER_CC_FLAGS) $(AFMAC_INCLUDES) $(AFMAC_LIBPATH) \
	$(AFMAC_CFLAGS) $(AFMAC_LFLAGS) 
	$(AFMAC_CC_SIZE) $(AFMAC_OUTPUT) 
	@echo ""

AFMAC_programclean:
	rm -f $(AFMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION DOCMAC
#################################################################

DOCMAC_program: $(DOCMAC_OUTPUT) 

$(DOCMAC_OUTPUT) : $(DOCMAC_SOURCES) $(DOCMAC_HEADERS) $(DOCMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/docmac_compiler.opt
	@mkdir -p $(DOCMAC_OUTPUT_DIR) 
	$(DOCMAC_CC) $(DOCMAC_CC_OPT) $(DOCMAC_SOURCES) -o $(DOCMAC_OUTPUT) \
	$(DOCMAC_OTHER_CC_FLAGS) $(DOCMAC_INCLUDES) $(DOCMAC_LIBPATH) \
	$(DOCMAC_CFLAGS) $(DOCMAC_LFLAGS) 
	$(DOCMAC_CC_SIZE) $(DOCMAC_OUTPUT) 
	@echo ""

DOCMAC_programclean:
	rm -f $(DOCMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION DEBUGMAC
#################################################################

DebugMAC_program: $(DEBUGMAC_OUTPUT) 

$(DEBUGMAC_OUTPUT) : $(DEBUGMAC_SOURCES) $(DEBUGMAC_HEADERS) $(DEBUGMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/debugmac_compiler.opt
	@mkdir -p $(DEBUGMAC_OUTPUT_DIR) 
	$(DEBUGMAC_CC) $(DEBUGMAC_CC_OPT) $(DEBUGMAC_SOURCES) -o $(DEBUGMAC_OUTPUT) \
	$(DEBUGMAC_OTHER_CC_FLAGS) $(DEBUGMAC_INCLUDES) $(DEBUGMAC_LIBPATH) \
	$(DEBUGMAC_CFLAGS) $(DEBUGMAC_LFLAGS) 
	$(DEBUGMAC_CC_SIZE) $(DEBUGMAC_OUTPUT) 
	@echo ""

DebugMAC_programclean:
	rm -f $(DEBUGMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION BERMAC
#################################################################

BERMAC_program: $(BERMAC_OUTPUT) 

$(BERMAC_OUTPUT) : $(BERMAC_SOURCES) $(BERMAC_HEADERS) $(BERMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/bermac_compiler.opt
	@mkdir -p $(BERMAC_OUTPUT_DIR) 
	$(BERMAC_CC) $(BERMAC_CC_OPT) $(BERMAC_SOURCES) -o $(BERMAC_OUTPUT) \
	$(BERMAC_OTHER_CC_FLAGS) $(BERMAC_INCLUDES) $(BERMAC_LIBPATH) \
	$(BERMAC_CFLAGS) $(BERMAC_LFLAGS) 
	$(BERMAC_CC_SIZE) $(BERMAC_OUTPUT) 
	@echo ""

BERMAC_programclean:
	rm -f $(BERMAC_OUTPUT) 

#################################################################
# SOFTWARE APPLICATION WARPNET_CSMAMAC
#################################################################

WARPNET_CSMAMAC_program: $(WARPNET_CSMAMAC_OUTPUT) 

$(WARPNET_CSMAMAC_OUTPUT) : $(WARPNET_CSMAMAC_SOURCES) $(WARPNET_CSMAMAC_HEADERS) $(WARPNET_CSMAMAC_LINKER_SCRIPT) \
                    $(LIBRARIES) __xps/warpnet_csmamac_compiler.opt
	@mkdir -p $(WARPNET_CSMAMAC_OUTPUT_DIR) 
	$(WARPNET_CSMAMAC_CC) $(WARPNET_CSMAMAC_CC_OPT) $(WARPNET_CSMAMAC_SOURCES) -o $(WARPNET_CSMAMAC_OUTPUT) \
	$(WARPNET_CSMAMAC_OTHER_CC_FLAGS) $(WARPNET_CSMAMAC_INCLUDES) $(WARPNET_CSMAMAC_LIBPATH) \
	$(WARPNET_CSMAMAC_CFLAGS) $(WARPNET_CSMAMAC_LFLAGS) 
	$(WARPNET_CSMAMAC_CC_SIZE) $(WARPNET_CSMAMAC_OUTPUT) 
	@echo ""

WARPNET_CSMAMAC_programclean:
	rm -f $(WARPNET_CSMAMAC_OUTPUT) 

#################################################################
# BOOTLOOP ELF FILES
#################################################################



$(PPC405_0_BOOTLOOP): $(PPC405_BOOTLOOP)
	@mkdir -p $(BOOTLOOP_DIR)
	cp -f $(PPC405_BOOTLOOP) $(PPC405_0_BOOTLOOP)

#################################################################
# HARDWARE IMPLEMENTATION FLOW
#################################################################


$(BMM_FILE) \
$(WRAPPER_NGC_FILES): $(MHSFILE) __xps/platgen.opt \
                      $(CORE_STATE_DEVELOPMENT_FILES)
	@echo "****************************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "****************************************************"
	platgen $(PLATGEN_OPTIONS) $(MHSFILE)

$(POSTSYN_NETLIST): $(WRAPPER_NGC_FILES)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh"

__xps/$(SYSTEM)_routed: $(FPGA_IMP_DEPENDENCY)
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	@cp -f $(UCF_FILE) implementation/$(SYSTEM).ucf
	xilperl $(NON_CYG_XILINX_EDK_DIR)/data/fpga_impl/manage_fastruntime_opt.pl $(MANAGE_FASTRT_OPTIONS)
	xflow -wd implementation -p $(DEVICE) -implement xflow.opt $(SYSTEM).ngc
	touch __xps/$(SYSTEM)_routed

$(SYSTEM_BIT): __xps/$(SYSTEM)_routed $(BITGEN_UT_FILE)
	xilperl $(NON_CYG_XILINX_EDK_DIR)/data/fpga_impl/observe_par.pl $(OBSERVE_PAR_OPTIONS) implementation/$(SYSTEM).par
	@echo "*********************************************"
	@echo "Running Bitgen.."
	@echo "*********************************************"
	@cp -f $(BITGEN_UT_FILE) implementation/bitgen.ut
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

$(DOWNLOAD_BIT): $(BRAMINIT_ELF_FILES) __xps/bitinit.opt
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT) $(BRAMINIT_ELF_FILE_ARGS) \
	-bt $(SYSTEM_BIT) -o $(DOWNLOAD_BIT)
	@rm -f $(SYSTEM)_bd.bmm

$(SYSTEM_ACE): $(DOWNLOAD_BIT) $(CSMAMAC_OUTPUT) $(AFMAC_OUTPUT) $(DOCMAC_OUTPUT) $(DEBUGMAC_OUTPUT) $(BERMAC_OUTPUT) $(WARPNET_CSMAMAC_OUTPUT) 
	@echo "*********************************************"
	@echo "Creating system ace file"
	@echo "*********************************************"
	xmd -tcl genace.tcl -jprog -hw $(DOWNLOAD_BIT) -elf $(CSMAMAC_OUTPUT) $(AFMAC_OUTPUT) $(DOCMAC_OUTPUT) $(DEBUGMAC_OUTPUT) $(BERMAC_OUTPUT) $(WARPNET_CSMAMAC_OUTPUT)  -target ppc_hw  -ace $(SYSTEM_ACE)

#################################################################
# SIMULATION FLOW
#################################################################


################## BEHAVIORAL SIMULATION ##################

$(BEHAVIORAL_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)

################## STRUCTURAL SIMULATION ##################

$(STRUCTURAL_SIM_SCRIPT): $(WRAPPER_NGC_FILES) __xps/simgen.opt \
                          $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)


################## TIMING SIMULATION ##################

$(TIMING_SIM_SCRIPT): $(SYSTEM_BIT) __xps/simgen.opt \
                      $(BRAMINIT_ELF_FILES)
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)

#################################################################
# VIRTUAL PLATFORM FLOW
#################################################################


$(VPEXEC): $(MHSFILE) __xps/vpgen.opt
	@echo "****************************************************"
	@echo "Creating virtual platform for hardware specification.."
	@echo "****************************************************"
	vpgen $(VPGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

